#include <stdio.h>
#include "Fluid.h"
#include "ParticleUpdate.h"

#define SIDES 16

//Particle System Functions/
ParticleSystem::ParticleSystem(float milestone, char* Texture) :
   milestone(milestone),
   TextureFile(Texture)
{}

void ParticleSystem::initialize() {
  float particleYPos = SIDES;
  float particleXPos = -SIDES;
  float particleZPos = SIDES;
  int particleCount = 1;

  for (int i = 0; i < NUM_PARTICLES; i++) {
    if (particleCount % (SIDES + 1) == 0) {
      particleXPos = -SIDES;
      if (particleZPos != -SIDES) {
        particleZPos--;
      }
      else {
        particleZPos = SIDES;
        particleYPos--;
      }
    }
    else {
      particleXPos++;
    }
    particles[i].position.x = particleXPos;
    particles[i].position.y = particleYPos;
    particles[i].position.z = particleZPos;
    particles[i].velocity.x = 0;
    particles[i].velocity.y = 0;
    particles[i].velocity.z = 0;
    particles[i].newVelocity.x = 0;
    particles[i].newVelocity.y = 0;
    particles[i].newVelocity.z = 0;
    particles[i].radius = RADIUS;
    particleCount++;
  }
}

void ParticleSystem::initializeDrop() {
  float particleYPos = 0;
  float particleDropYPos = SIDES;
  float particleXPos = -SIDES;
  float particleDropXPos = -SIDES / 2;
  float particleZPos = SIDES;
  float particleDropZPos = SIDES/ 2;
  int particleCount = 1;

  for (int i = 0; i < NUM_PARTICLES; i++) {
    particles[i].velocity.x = 0;
    particles[i].velocity.y = 0;
    particles[i].velocity.z = 0;
    particles[i].newVelocity.x = 0;
    particles[i].newVelocity.y = 0;
    particles[i].newVelocity.z = 0;

    if (i < NUM_PARTICLES - 2000) {
      if (particleCount % (SIDES * 2) == 0) {
        particleXPos = -SIDES;
        if (particleZPos != -SIDES) {
          particleZPos--;
        }
        else {
          particleZPos = SIDES;
          particleYPos--;
        }
      }
      else {
        particleXPos++;
      }
      particles[i].position.x = particleXPos;
      particles[i].position.y = particleYPos;
      particles[i].position.z = particleZPos;
    }
    else {
      if (particleCount % (SIDES + 1) == 0) {
        particleDropXPos = -SIDES / 2;
        if (particleDropZPos != -SIDES / 2) {
          particleDropZPos--;
        }
        else {
          particleDropZPos = SIDES / 2;
          particleDropYPos--;
        }
      }
      else {
        particleDropXPos++;
      }
      particles[i].position.x = particleDropXPos;
      particles[i].position.y = particleDropYPos;
      particles[i].position.z = particleDropZPos;
    }
    particles[i].radius = RADIUS;
    particleCount++;
  }
}

void ParticleSystem::update(float forceX, float forceY, float forceZ,
                            float deltaTime, float spring, float wallDamp,
                            float partDamp, float shear) {
  my_vec3 force;
  force.x = forceX;
  force.y = forceY;
  force.z = forceZ;

  updateParticles(particles, NUM_PARTICLES, force,
                  deltaTime, spring, wallDamp,
                  partDamp, shear);
}
