#ifndef PARTICLE_UPDATE_H
#define PARTICLE_UPDATE_H

#include <cuda.h>
#include <cuda_runtime_api.h>
#include "Fluid.h"

void updateParticles(Particle *particles, int size, my_vec3 localExtForce,
                     float deltaTime, float spring, float wallDamp,
                     float partDamp, float shear);
void updateGrid(Particle *particles, int *gridCounter, int *gridCells);
__global__ void updateParticleKernel(Particle *particles, my_vec3 *extForce,
                                     int *gridCounter, int *gridCells,
                                     float DELTA_TIME, float SPRING_FORCE,
                                     float WALL_DAMP_FORCE,
                                     float PART_DAMP_FORCE,
                                     float SHEAR_FORCE);
__device__ my_vec3 updateParticleInCells(Particle *particles, int *gridCounter,
                                         int *gridCells, int idx,
                                         float DELTA_TIME, float SPRING_FORCE,
                                         float WALL_DAMP_FORCE,
                                         float PART_DAMP_FORCE,
                                         float SHEAR_FORCE);
__device__ float circleDistance(my_vec3 *firstSphere, my_vec3 *secondSphere);
__device__ my_vec3 checkCells(int x, int y, int z, int idx,
                              Particle *particles,
                              int *gridCounter,
                              int *gridCells,
                              float DELTA_TIME, float SPRING_FORCE,
                              float WALL_DAMP_FORCE,
                              float PART_DAMP_FORCE,
                              float SHEAR_FORCE);

#endif
